/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved    */
/* b t b i n a r y . c:   btree nodes binary search routines.     8/02/84 */

/*----------------------------------------------------------------------------
 * binarysr() performs a binary search of the index node type O (i.e.
 * index nodes with pointers to other index nodes at the lower levels).
 *---------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------
 * binarydt() performs a binary search of the index node type 1 (i.e.
 * terminating index nodes with pointers to the data records).
 *---------------------------------------------------------------------------*/

#include "cbtree.h"

binarysr(pblk, srchkey, sl)
struct btidxblk *pblk;
char *srchkey;
unsigned sl;
{
   extern long lseek();
   extern int    strncmp();
   int low = 0;
   int high = pblk->cellicnt - 1;
   int mid;
   int cond;

   while (low <= high) {
      mid = (low + high) / 2;
      if ( (cond = strncmp(srchkey, pblk->btpage[mid].skeynme, sl) ) < 0)
         high = mid - 1;

      else if (cond > 0)
         low = mid + 1;

      else
      {           /* found (partial) match, return FIRST dup    */
         while (mid-- > 0 &&
               strncmp(srchkey, pblk->btpage[mid].skeynme, sl) == 0)
            ;

         if (++mid >= pblk->cellicnt)
            return ((int)(pblk->cellicnt - 1));
         return(mid);
      }
   }

   /* match not found */
   while (strncmp(srchkey, pblk->btpage[mid++].skeynme, sl) > 0)
      if (mid >= pblk->cellicnt)       /* check for array upper bounds   */
         break;

   return (--mid); /* return location of next index node to follow */
}

/* binary search function of type 1 (data page pointer) page   */
/* 01/26/85 */

binarydt(fdidx, pblk, btcp, sl, match, dupflg)
int fdidx;
BTIDXBLK *pblk;
BTC      *btcp;
unsigned sl, *match, *dupflg;
{
   extern long lseek();
   extern int  strncmp(), strlen();
   extern void free();
   extern char *calloc();
   int   low = 0;
   int   high = pblk->cellicnt - 1;
   int   mid;
   int   cond;
   char *keyp;
   int   keyplen;

   if (btcp->btsvkey != NULL)
      keyp = btcp->btsvkey;
   else
      keyp = btcp->btkey;
   keyplen = strlen(keyp);

   while (low <= high)
   {
      mid = (low + high) / 2;           /* set search starting point */

      if ((cond = strncmp(keyp, pblk->btpage[mid].skeynme, keyplen)) < 0)
         high = mid - 1;                     /* search lower half */

      else if(cond > 0)
         low = mid + 1;              /* search upper half */

      else
      {                               /* FOUND MATCH: check for dups */
         *dupflg = 0;

         if (mid < pblk->cellicnt - 1)   /* check upper bounds */
         {
            if (strncmp(btcp->btkey, pblk->btpage[mid + 1].skeynme, sl) == 0)
               *dupflg = 1;               /* look right for dups    */
         }
         else if (pblk->fwdpage > 0L) /* have to check right neighbor */
         {
            BTIDXBLK *neighbor;       /* for right index blk */
            int       i;

            i = sizeof(BTIDXBLK) + btcp->btcells * sizeof(BTIDX);
            if ((char *)(neighbor = (BTIDXBLK *)calloc(i, SZCHAR)) == NULL)
               ckerror(- CK_NOMEM, "108");
            neighbor->blkalloc = 0;
            getidxr(fdidx, pblk->fwdpage, neighbor, btcp->btidxlen, sl);
            if (strncmp(btcp->btkey, neighbor->btpage[0].skeynme, sl) == 0)
               *dupflg = 1;            /* duplicate key found in right blk */
            freekeys(neighbor);
            FREE(neighbor);
         }

         /* check array lower bounds   */
         while (mid-- > 0 && strncmp(btcp->btkey, pblk->btpage[mid].skeynme,
               sl) == 0)
            *dupflg = 1;      /* look ALL THE WAY LEFT for dups      */
         *match = 1;
         return(++mid);   /* return LOWEST match location */
      }
   }

   /* NO MATCH FOUND: return INSERT location */
   while (strncmp(keyp, pblk->btpage[mid++].skeynme, keyplen) > 0)
      if (mid > pblk->cellicnt)       /* check for array upper bounds */
         break;
   *match = 0;
   return(--mid);   /* return location to insert new record     */
}
